summaryrefslogtreecommitdiff
path: root/tests/cp
diff options
context:
space:
mode:
authorOndřej Vašík <ovasik@redhat.com>2009-04-27 17:20:23 +0200
committerJim Meyering <meyering@redhat.com>2009-04-28 11:16:29 +0200
commit8259a73a85c5ef46c26da27f9424aeed360fa2cd (patch)
treefe47106b7fd0d4689c326b9b3a7bb881f255dc68 /tests/cp
parente0cf592f48b4e67dc31d0482ae4f4dbc820e883e (diff)
downloadcoreutils-8259a73a85c5ef46c26da27f9424aeed360fa2cd.tar.xz
tests: add test for xattr diagnostics on dest. FS lacking xattr support
* tests/cp/cp-mv-enotsup-xattr: Ensure that xattr diagnostics are displayed correctly when destination filesystem lacks xattr support. * tests/Makefile.am (root_tests): Add new root-only test.
Diffstat (limited to 'tests/cp')
-rwxr-xr-xtests/cp/cp-mv-enotsup-xattr90
1 files changed, 90 insertions, 0 deletions
diff --git a/tests/cp/cp-mv-enotsup-xattr b/tests/cp/cp-mv-enotsup-xattr
new file mode 100755
index 000000000..23ec4f372
--- /dev/null
+++ b/tests/cp/cp-mv-enotsup-xattr
@@ -0,0 +1,90 @@
+#!/bin/sh
+# Ensure that mv, cp -a and cp --preserve=xattr(all) options do work
+# as expected on file system without their support and do show correct
+# diagnostics when required
+
+# Copyright (C) 2009 Free Software Foundation, Inc.
+
+# This program is free software: you can redistribute it and/or modify
+# it under the terms of the GNU General Public License as published by
+# the Free Software Foundation, either version 3 of the License, or
+# (at your option) any later version.
+
+# This program is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
+# GNU General Public License for more details.
+
+# You should have received a copy of the GNU General Public License
+# along with this program. If not, see <http://www.gnu.org/licenses/>.
+
+if test "$VERBOSE" = yes; then
+ set -x
+ cp --version
+ mv --version
+fi
+
+. $srcdir/test-lib.sh
+require_root_
+
+cwd=`pwd`
+cleanup_() { cd /; umount "$cwd/mnt"; }
+
+# Create a file system without user xattr support, then mount it.
+dd if=/dev/zero of=blob bs=8192 count=200 > /dev/null 2>&1 \
+ || framework_failure
+mkdir mnt || framework_failure
+mkfs -t ext2 -F blob ||
+ skip_test_ "failed to create ext2 file system"
+
+mount -oloop,nouser_xattr blob mnt || framework_failure
+echo test > mnt/f || framework_failure
+test -s mnt/f || framework_failure
+
+# testing xattr name-value pair
+xattr_name="user.foo"
+xattr_value="bar"
+xattr_pair="$xattr_name=\"$xattr_value\""
+
+echo test > a || framework_failure
+getfattr -d a >out_a || skip_test_ "failed to get xattr of file"
+grep -F "$xattr_pair" out_a >/dev/null && framework_failure
+setfattr -n "$xattr_name" -v "$xattr_value" a >out_a \
+ || skip_test_ "failed to set xattr of file"
+getfattr -d a >out_a || skip_test_ "failed to get xattr of file"
+grep -F "$xattr_pair" out_a >/dev/null \
+ || skip_test_ "failed to set xattr of file"
+
+fail=0 || framework_failure
+
+
+# This should pass without diagnostics
+cp -a a mnt/ 2>err || fail=1
+test -s mnt/a || fail=1 # destination file must not be empty
+test -s err && fail=1 # there must be no stderr output
+
+rm -f err mnt/a
+
+# This should pass without diagnostics
+cp --preserve=all a mnt/ 2>err || fail=1
+test -s mnt/a || fail=1 # destination file must not be empty
+test -s err && fail=1 # there must be no stderr output
+
+rm -f err mnt/a
+
+# This should fail with coresponding diagnostics
+cp -a --preserve=xattr a mnt/ 2>err && fail=1
+cat <<\EOF > exp || fail=1
+cp: setting attributes for `mnt/a': Operation not supported
+EOF
+
+compare err exp || fail=1
+
+rm -f err mnt/a
+
+# This should pass without diagnostics
+mv a mnt/ 2>err || fail=1
+test -s mnt/a || fail=1 # destination file must not be empty
+test -s err && fail=1 # there must be no stderr output
+
+Exit $fail